dofile("system/fonctions.lua")
noir = Color.new(0,0,0)
blanc = Color.new(255,255,255,0)
map = 1
nbr_offi = 30
nbr_perso = 10
nbr_map = nbr_offi
fond = Image.load("img/fond.png")
police = Font.load("img/police.ttf")
police:setPixelSizes(0, 18)
etape = 1
select = 140
minut = Timer.new()
minut:start()
repertoir = ""
lieu = ""

while true do
screen:clear()
screen:blit(0,0,fond)
pad = Controls.read()
tem = minut:time()

if etape == 1 or etape == 2 then
	screen:fontPrint(police,20,22,"choisir le repertoir : ",blanc)
	screen:fontPrint(police,70,140,"cartes officielles",noir)
	screen:fontPrint(police,70,170,"cartes persos",noir)
	screen:fontPrint(police,40,select,">>",noir)
end
if etape == 3 then
	file = io.open("maps/"..lieu.."/map"..map..".txt", "r")
	ligneh = file:read()
	lignev = file:read()
	name = file:read()
	mursmax = tonumber(file:read())
	diff = file:read()
	app1 = file:read()
	app2 = file:read()
	app3 = file:read()
	file:close()
	if name == nil or name == "" then
		name = "vide "
	end
	if app1 == nil or app1 == "" then
		app1 = "carte vide "
		app2 = "ne peut etre lancee "
		app3 = " "
	end
	if diff == nil or diff == "" then
		diff = " "
	end
	if mursmax == nil or mursmax == "" then
		mursmax = " "
	end
	screen:fontPrint(police,20,22,"choisir la carte - repertoir actuel : "..repertoir,blanc)
	screen:fontPrint(police,80,60,"< Carte : "..string.sub(name,1,string.len(name)-1).." ("..map..") >",noir)
	screen:fontPrint(police,30,110,"Description : ",noir)
	screen:fontPrint(police,30,135,string.sub(app1,1,string.len(app1)-1),noir)
	screen:fontPrint(police,30,155,string.sub(app2,1,string.len(app2)-1),noir)
	screen:fontPrint(police,30,175,string.sub(app3,1,string.len(app3)-1),noir)
	screen:fontPrint(police,340,160,"Difficulte : ",noir)
	screen:fontPrint(police,340,175,string.sub(diff,1,string.len(diff)-1),noir)
	screen:fontPrint(police,340,205,"Pushs maxi : "..mursmax,noir)
	if name ~= "vide" and mursmax ~= " " then
		screen:fontPrint(police,95,240,"start : Commencer",noir)
	end
end

if tem > 100 then
	minut:reset(0)
	etape = 2
end

if pad ~= oldPad then
	if etape == 2 then
		if pad:up() or pad:down() then
			if select == 140 then
				select = 170
			else
				select = 140
			end    
		end
		if pad:cross() then
			etape = 3
			map = 1
			if select == 140 then
				repertoir = "cartes officielles"
				lieu = ""
				nbr_map = nbr_offi
			else
				repertoir = "cartes persos"
				lieu = "perso"
				nbr_map = nbr_perso
			end
		end
		if pad:circle() then
			dofile("system/menu.lua")
		end
	end
	if etape == 3 then
		if pad:right() then
			map = map + 1
			if map > nbr_map then
				map = 1
			end
		end
		if pad:left() then
			map = map - 1
			if map < 1 then
				map = nbr_map
			end
		end
		if pad:start() and name ~= "vide" and mursmax ~= " " then
			break
		end
		if pad:circle() then
			etape = 1
			minut:start()
		end
	end
	oldPad = pad
end

screen.flip()
screen.waitVblankStart()
end

--------------------------------
dofile("system/fonctions.lua")
--------------------------------

rouge = Color.new(255,0,0)
bleu = Color.new(0,0,255)
vert = Color.new(0,255,0)

bas = {}
bas[1] = {x=1, y=3, lg=31, h=43}
bas[2] = {x=33, y=3, lg=31, h=43}
bas[3] = {x=65, y=3, lg=31, h=43}
bas[4] = {x=97, y=3, lg=31, h=43}

haut = {}
haut[1] = {x=0, y=146, lg=31, h=44}
haut[2] = {x=32, y=146, lg=31, h=44}
haut[3] = {x=64, y=146, lg=31, h=44}
haut[4] = {x=96, y=146, lg=31, h=44}

gauche = {}
gauche[1] = {x=6, y=52, lg=24, h=42}
gauche[2] = {x=38, y=52, lg=24, h=42}
gauche[3] = {x=70, y=52, lg=24, h=42}
gauche[4] = {x=101, y=52, lg=25, h=42}

droite = {}
droite[1] = {x=2, y=100, lg=24, h=42}
droite[2] = {x=34, y=100, lg=24, h=42}
droite[3] = {x=66, y=100, lg=24, h=42}
droite[4] = {x=98, y=100, lg=24, h=42}

file = io.open("system/option.txt", "r")
imgsol = tonumber(file:read())
imgjoueur = tonumber(file:read())
file:close()
sol = Image.load("img/sol"..imgsol..".png")
joueur = Image.load("perso/"..imgjoueur..".png")

direction = "droite"
action = "non"
present = 0
murH = Image.load("img/murh.png")
murV = Image.load("img/murv.png")
murnonH = Image.load("img/murnonh.png")
murnonV = Image.load("img/murnonv.png")
porteH = Image.load("img/porteh.png")
porteV = Image.load("img/portev.png")
tourH = Image.load("img/tourh.png")
tourV = Image.load("img/tourv.png")
tourH2 = Image.load("img/tourh2.png")
tourV2 = Image.load("img/tourv2.png")
minicarte = Image.load("img/minicarte.png")
pointeur = Image.load("img/pointeur.png")
sorti = Image.load("img/sorti.png")
minuteur = Timer.new()
minuteur:reset(0)
nstart = Timer.new()
nstart:reset(0)
chrono = Timer.new()
chrono:start()
statut = 1
ac = 0
vit = 4
boug = 1
dep = 0
murspousses = 0
gagner = 0
nombre = 0
sortie = {}

posx = 15
posy = 20
casehoriz = 30
casevert = 25
caseH = 1
caseV = casevert - 2

H={}
V={}
file = io.open("maps/"..lieu.."/map"..map..".txt", "r")
ligneh = file:read()
lignev = file:read()
name = file:read()
mursmax = tonumber(file:read())
diff = file:read()
app1 = file:read()
app2 = file:read()
app3 = file:read()
file:close()
for a = 1, (casehoriz*casevert) do
	H[a] = tonumber(string.sub(tostring(ligneh),a,a))
end
for a = 1, (casehoriz*casevert) do
	V[a] = tonumber(string.sub(tostring(lignev),a,a))
end

--haut
for a = 1, 29 do
	if H[a] == 0 then
		nombre = nombre + 1
		sortie[nombre] = a
	end
end

--bas
for a = 721, 749 do
	if H[a] == 0 then
		nombre = nombre + 1
		sortie[nombre] = a
	end
end

--gauche
for a = 0, 23 do
	if V[1+a*30] == 0 then
		nombre = nombre + 1
		sortie[nombre] = 1+a*30
	end
end

--droite
for a = 1, 23 do
	if V[a*30] == 0 then
		nombre = nombre + 1
		sortie[nombre] = a*30
	end
end

posxsortie = {}
posysortie = {}
for a = 1, nombre do
	n = (sortie[a]-1)/30
	posxsortie[a] = (n-math.modf(n))*75+40
	posysortie[a] = (math.modf(n))*(8/3)+176
end

while true do
screen:clear()

temp = minuteur:time()
nstart_time = nstart:time()
chrono_time = chrono:time()
pad = Controls.read()

--deplacement joueur 1
if ac == 1 then
	if temp <= 100 then
		statut = 1
	elseif temp > 100 and temp <= 200 then
		statut = 2
	elseif temp > 200 and temp <= 300 then
		statut = 3
	elseif temp > 300 and temp <= 400 then
		statut = 4
	elseif temp > 400 then
		minuteur:stop()
		minuteur:reset(0)
		action = "non"
	end
elseif ac == 0 then
	minuteur:stop()
	minuteur:reset(0)
	action = "non"
end

--affichage sol
screen:blit(posx*-1,posy*-1,sol)

--affichage murs dessous joueur
for b = 0, 3 do
	for a = 1, 12 do
		if (caseH-6+a)>0 and (caseV-3+b)>-1 and (caseH-6+a) < casehoriz+1 and (caseV-3+b) < casevert then
			if H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 1 then
				screen:blit(a*50-posx-75,b*50-posy-26,murH)
			elseif H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 2 then
				screen:blit(a*50-posx-75,b*50-posy-26,porteH)
			elseif H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 3 then
				screen:blit(a*50-posx-75,b*50-posy-26,murnonH)
			elseif H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 4 then
				screen:blit(a*50-posx-75,b*50-posy-26,tourH)
			elseif H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 5 then
				screen:blit(a*50-posx-75,b*50-posy-26,tourH2)
			end
		end
	end
	for a = 1, 12 do
		if (caseH-6+a)>0 and (caseV-3+b)>-1 and (caseH-6+a) < casehoriz+1 then
			if V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 1 then
				screen:blit(a*50-posx-75,b*50-posy-26,murV)
			elseif V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 2 then
				screen:blit(a*50-posx-75,b*50-posy-26,porteV)
			elseif V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 3 then
				screen:blit(a*50-posx-75,b*50-posy-26,murnonV)
			elseif V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 4 then
				screen:blit(a*50-posx-75,b*50-posy-26,tourV)
			elseif V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 5 then
				screen:blit(a*50-posx-75,b*50-posy-26,tourV2)
			end
		end
	end
end

--affichage joueur 1
if direction == "enhaut" then
	if action == "oui" then
		screen:blit(225, 116, joueur, haut[statut].x, haut[statut].y, haut[statut].lg, haut[statut].h)
	else
		screen:blit(225, 116, joueur, haut[1].x, haut[1].y, haut[1].lg, haut[1].h)
	end
end

if direction == "enbbas" then
	if action == "oui" then
		screen:blit(225, 116, joueur, bas[statut].x, bas[statut].y, bas[statut].lg, bas[statut].h)
	else
		screen:blit(225, 116, joueur, bas[1].x, bas[1].y, bas[1].lg, bas[1].h)
	end
end

if direction == "gauche" then
	if action == "oui" then
		screen:blit(225, 116, joueur, gauche[statut].x, gauche[statut].y, gauche[statut].lg, gauche[statut].h)
	else
		screen:blit(225, 116, joueur, gauche[1].x, gauche[1].y, gauche[1].lg, gauche[1].h)
	end
end

if direction == "droite" then
	if action == "oui" then
		screen:blit(225, 116, joueur, droite[statut].x, droite[statut].y, droite[statut].lg, droite[statut].h)
	else
		screen:blit(225, 116, joueur, droite[1].x, droite[1].y, droite[1].lg, droite[1].h)
	end
end

--affichage murs dessus joueur
for b = 4, 7 do
	for a = 1, 12 do
		if (caseH-6+a)>0 and (caseV-3+b)>-1 and (caseH-6+a) < casehoriz+1 then
			if H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 1 then
				screen:blit(a*50-posx-75,b*50-posy-26,murH)
			elseif H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 2 then
				screen:blit(a*50-posx-75,b*50-posy-26,porteH)
			elseif H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 4 then
				screen:blit(a*50-posx-75,b*50-posy-26,tourH)
			elseif H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 5 then
				screen:blit(a*50-posx-75,b*50-posy-26,tourH2)
			elseif H[(caseH-6+a)+casehoriz*(caseV-3+b)] == 3 then
				screen:blit(a*50-posx-75,b*50-posy-26,murnonH)
			end
		end
	end
	for a = 1, 12 do
		if (caseH-6+a)>0 and (caseV-3+b)>-1 and (caseH-6+a) < casehoriz+1 then
			if V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 1 then
				screen:blit(a*50-posx-75,b*50-posy-26,murV)
			elseif V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 2 then
				screen:blit(a*50-posx-75,b*50-posy-26,porteV)
			elseif V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 4 then
				screen:blit(a*50-posx-75,b*50-posy-26,tourV)
			elseif V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 5 then
				screen:blit(a*50-posx-75,b*50-posy-26,tourV2)
			elseif V[(caseH-6+a)+casehoriz*(caseV-3+b)] == 3 then
				screen:blit(a*50-posx-75,b*50-posy-26,murnonV)
			end
		end
	end
end

--test murs exterieurs
--haut
for a = 2, 29 do
	if H[a] == 0 then
		if H[a-1] ~= 0 and H[a-1] ~= 4 then
			H[a-1] = 4
		end
		if H[a+1] ~= 0 and H[a+1] ~= 5 then
			H[a+1] = 5
		end
	end
end

--bas
for a = 722, 749 do
	if H[a] == 0 then
		if H[a-1] ~= 0 and H[a-1] ~= 4 then
			H[a-1] = 4
		end
		if H[a+1] ~= 0 and H[a+1] ~= 5 then
			H[a+1] = 5
		end
	end
end

--gauche
for a = 1, 22 do
	if V[1+a*30] == 0 then
		if V[1+a*30-30] ~= 0 and V[1+a*30-30] ~= 4 then
			V[1+a*30-30] = 4
		end
		if V[1+a*30+30] ~= 0 and V[1+a*30+30] ~= 5 then
			V[1+a*30+30] = 5
		end
	end
end

--droite
for a = 1, 22 do
	if V[a*30] == 0 then
		if V[a*30-30] ~= 0 and V[a*30-30] ~= 4 then
			V[a*30-30] = 4
		end
		if V[a*30+30] ~= 0 and V[a*30+30] ~= 5 then
			V[a*30+30] = 5
		end
	end
end

--mini catre
screen:blit(15,157,minicarte)
posxperso = (caseH-1)*50+posx
posyperso = caseV*50+posy
posxmini = posxperso/20+41
posymini = posyperso/20+179
screen:blit(posxmini-3,posymini-3,pointeur)
for a = 1, nombre do
	screen:blit(posxsortie[a]-3,posysortie[a]-3,sorti)
end

if caseV == 0 and posy < 5 then
	gagner = 1
end
if caseV == casevert-2 and posy > 45 then
	gagner = 1
end
if caseH == 1 and posx < 5 then
	gagner = 1
end
if caseH == casehoriz-1 and posx > 25 then
	gagner = 1 
end

if pad:start() then
	pause()
end

if nstart_time > 300 then
	nstart:reset(0)
end

move()
pousse()
victoire_solo()

screen.waitVblankStart()
screen:flip()
end
